// aid to help looking for those special somethings

freeslot("sfx_splook")

local spradius = CV_RegisterVar({
	name = "sp_radius",
	defaultvalue = "512",
	flags = CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = {MIN = 0, MAX = 2500}
})

addHook("MobjThinker", function(token)
	local distance = spradius.value
	if token.soundtime == nil
		token.soundtime = 0
	end
	P_SpawnMobj(token.x + cos(FixedAngle(token.angle))*FixedMul(distance, token.scale), token.y + sin(FixedAngle(token.angle))*FixedMul(distance, token.scale), token.z, MT_SUPERSPARK)
	P_SpawnMobj(token.x + cos(FixedAngle(token.angle))*FixedMul(-distance, token.scale), token.y + sin(FixedAngle(token.angle))*FixedMul(-distance, token.scale), token.z, MT_SUPERSPARK)
	local radiusspark = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark2 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark2.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark3 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark3.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark4 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark4.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark5 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark5.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark6 = P_SpawnMobjFromMobj(token, token.x,  token.y, token.z, MT_SUPERSPARK)
	radiusspark6.momz = 35*FRACUNIT
	token.angle = $1 + ANG30
	token.soundtime = $ + 1
	if token.soundtime == 100
		token.soundtime = 0
		S_StartSoundAtVolume(token, sfx_splook, 255)
	end
end, MT_TOKEN)

addHook("MobjThinker", function(token)
	local distance = spradius.value
	if token.soundtime == nil
		token.soundtime = 0
	end
	P_SpawnMobj(token.x + cos(FixedAngle(token.angle))*FixedMul(distance, token.scale), token.y + sin(FixedAngle(token.angle))*FixedMul(distance, token.scale), token.z, MT_SUPERSPARK)
	P_SpawnMobj(token.x + cos(FixedAngle(token.angle))*FixedMul(-distance, token.scale), token.y + sin(FixedAngle(token.angle))*FixedMul(-distance, token.scale), token.z, MT_SUPERSPARK)
	P_SpawnMobj(token.x + P_RandomRange(-distance,distance), token.y + P_RandomRange(-distance,distance), token.z + P_RandomRange(-distance,distance), MT_SUPERSPARK)
	local radiusspark = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark2 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark2.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark3 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark3.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark4 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark4.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark5 = P_SpawnMobjFromMobj(token, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, 8*FRACUNIT, MT_SUPERSPARK)
	radiusspark5.momz = P_RandomRange(15, 35) * FRACUNIT
	local radiusspark6 = P_SpawnMobjFromMobj(token, token.x,  token.y, token.z, MT_SUPERSPARK)
	radiusspark6.momz = 35*FRACUNIT
	token.angle = $1 + ANG30
	token.soundtime = $ + 1
	if token.soundtime == 100 and token.flags & MF_SPECIAL
		token.soundtime = 0
		S_StartSoundAtVolume(token, sfx_splook, 255)
	end
end, MT_EMBLEM)

